import { TextService, PARSED_COLOR_TYPE, CanvasConfig, DefaultCamera, ContextService, SceneGraphService, RenderingContext, DisplayObjectPool, SCENE_GRAPH_EVENT, RENDER_REASON, Cullable, Renderable, AABB, getEuler, fromRotationTranslationScale, Camera, SHAPE, world, container, RenderingPluginContribution } from '@antv/g';
import RBush from 'rbush';
export { default as RBush } from 'rbush';
import { Component } from '@antv/g-ecs';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);

    if (enumerableOnly) {
      symbols = symbols.filter(function (sym) {
        return Object.getOwnPropertyDescriptor(object, sym).enumerable;
      });
    }

    keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i] != null ? arguments[i] : {};

    if (i % 2) {
      ownKeys(Object(source), true).forEach(function (key) {
        _defineProperty(target, key, source[key]);
      });
    } else if (Object.getOwnPropertyDescriptors) {
      Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
    } else {
      ownKeys(Object(source)).forEach(function (key) {
        Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
      });
    }
  }

  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}

function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}

function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };

  return _setPrototypeOf(o, p);
}

function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;

  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}

function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return self;
}

function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }

  return _assertThisInitialized(self);
}

function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();

  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
        result;

    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;

      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }

    return _possibleConstructorReturn(this, result);
  };
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

var NAMED_TAG = "named";
var INJECT_TAG = "inject";
var TAGGED = "inversify:tagged";
var TAGGED_PROP = "inversify:tagged_props";
var PARAM_TYPES = "inversify:paramtypes";
var DESIGN_PARAM_TYPES = "design:paramtypes";

var idCounter = 0;
function id() {
    return idCounter++;
}

var DUPLICATED_INJECTABLE_DECORATOR = "Cannot apply @injectable decorator multiple times.";
var DUPLICATED_METADATA = "Metadata key was used more than once in a parameter:";
var UNDEFINED_INJECT_ANNOTATION = function (name) {
    return "@inject called with undefined this could mean that the class " + name + " has " +
        "a circular dependency problem. You can use a LazyServiceIdentifer to  " +
        "overcome this limitation.";
};
var INVALID_DECORATOR_OPERATION = "The @inject @multiInject @tagged and @named decorators " +
    "must be applied to the parameters of a class constructor or a class property.";

var Metadata = (function () {
    function Metadata(key, value) {
        this.key = key;
        this.value = value;
    }
    Metadata.prototype.toString = function () {
        if (this.key === NAMED_TAG) {
            return "named: " + this.value.toString() + " ";
        }
        else {
            return "tagged: { key:" + this.key.toString() + ", value: " + this.value + " }";
        }
    };
    return Metadata;
}());

function tagParameter(annotationTarget, propertyName, parameterIndex, metadata) {
    var metadataKey = TAGGED;
    _tagParameterOrProperty(metadataKey, annotationTarget, propertyName, metadata, parameterIndex);
}
function tagProperty(annotationTarget, propertyName, metadata) {
    var metadataKey = TAGGED_PROP;
    _tagParameterOrProperty(metadataKey, annotationTarget.constructor, propertyName, metadata);
}
function _tagParameterOrProperty(metadataKey, annotationTarget, propertyName, metadata, parameterIndex) {
    var paramsOrPropertiesMetadata = {};
    var isParameterDecorator = (typeof parameterIndex === "number");
    var key = (parameterIndex !== undefined && isParameterDecorator) ? parameterIndex.toString() : propertyName;
    if (isParameterDecorator && propertyName !== undefined) {
        throw new Error(INVALID_DECORATOR_OPERATION);
    }
    if (Reflect.hasOwnMetadata(metadataKey, annotationTarget)) {
        paramsOrPropertiesMetadata = Reflect.getMetadata(metadataKey, annotationTarget);
    }
    var paramOrPropertyMetadata = paramsOrPropertiesMetadata[key];
    if (!Array.isArray(paramOrPropertyMetadata)) {
        paramOrPropertyMetadata = [];
    }
    else {
        for (var _i = 0, paramOrPropertyMetadata_1 = paramOrPropertyMetadata; _i < paramOrPropertyMetadata_1.length; _i++) {
            var m = paramOrPropertyMetadata_1[_i];
            if (m.key === metadata.key) {
                throw new Error(DUPLICATED_METADATA + " " + m.key.toString());
            }
        }
    }
    paramOrPropertyMetadata.push(metadata);
    paramsOrPropertiesMetadata[key] = paramOrPropertyMetadata;
    Reflect.defineMetadata(metadataKey, paramsOrPropertiesMetadata, annotationTarget);
}

function inject(serviceIdentifier) {
    return function (target, targetKey, index) {
        if (serviceIdentifier === undefined) {
            throw new Error(UNDEFINED_INJECT_ANNOTATION(target.name));
        }
        var metadata = new Metadata(INJECT_TAG, serviceIdentifier);
        if (typeof index === "number") {
            tagParameter(target, targetKey, index, metadata);
        }
        else {
            tagProperty(target, targetKey, metadata);
        }
    };
}

var __spreadArray = (undefined && undefined.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};

var __spreadArray$1 = (undefined && undefined.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};

var __awaiter = (undefined && undefined.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (undefined && undefined.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray$2 = (undefined && undefined.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};

var ContainerModule = (function () {
    function ContainerModule(registry) {
        this.id = id();
        this.registry = registry;
    }
    return ContainerModule;
}());

function injectable() {
    return function (target) {
        if (Reflect.hasOwnMetadata(PARAM_TYPES, target)) {
            throw new Error(DUPLICATED_INJECTABLE_DECORATOR);
        }
        var types = Reflect.getMetadata(DESIGN_PARAM_TYPES, target) || [];
        Reflect.defineMetadata(PARAM_TYPES, types, target);
        return target;
    };
}

/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}

function __metadata(metadataKey, metadataValue) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
}

var toString = {}.toString;
var isType = function (value, type) { return toString.call(value) === '[object ' + type + ']'; };

// isFinite,
var isNil = function (value) {
    /**
     * isNil(null) => true
     * isNil() => true
     */
    return value === null || value === undefined;
};

var isArray = (function (value) {
    return Array.isArray ?
        Array.isArray(value) :
        isType(value, 'Array');
});

var isString = (function (str) {
    return isType(str, 'String');
});

var DefaultRenderer = /*#__PURE__*/function () {
  function DefaultRenderer() {
    _classCallCheck(this, DefaultRenderer);
  }

  _createClass(DefaultRenderer, [{
    key: "render",
    value: function render(context, parsedStyle) {
      var fill = parsedStyle.fill,
          opacity = parsedStyle.opacity,
          fillOpacity = parsedStyle.fillOpacity,
          stroke = parsedStyle.stroke,
          strokeOpacity = parsedStyle.strokeOpacity,
          lineWidth = parsedStyle.lineWidth,
          lineCap = parsedStyle.lineCap,
          lineJoin = parsedStyle.lineJoin;

      if (!isNil(fill)) {
        if (!isNil(fillOpacity) && fillOpacity !== 1) {
          context.globalAlpha = fillOpacity;
          context.fill();
          context.globalAlpha = opacity;
        } else {
          context.fill();
        }
      }

      if (!isNil(stroke)) {
        if (lineWidth && lineWidth > 0) {
          var applyOpacity = !isNil(strokeOpacity) && strokeOpacity !== 1;

          if (applyOpacity) {
            context.globalAlpha = strokeOpacity;
          }

          context.lineWidth = lineWidth;

          if (!isNil(lineCap)) {
            context.lineCap = lineCap;
          }

          if (!isNil(lineJoin)) {
            context.lineJoin = lineJoin;
          } // prevent inner shadow when drawing stroke, toggle shadowBlur & filter(drop-shadow)
          // save shadow blur


          var shadowBlur = context.shadowBlur;
          var shadowColor = context.shadowColor;

          if (!isNil(shadowBlur)) {
            context.shadowColor = 'transparent';
            context.shadowBlur = 0;
          } // save drop-shadow filter


          var filter = context.filter;

          if (!isNil(filter) && filter.indexOf('drop-shadow') > -1) {
            context.filter = filter.replace(/drop-shadow\([^)]*\)/, '').trim() || 'none';
          }

          context.stroke(); // restore shadow blur

          if (!isNil(shadowBlur)) {
            context.shadowColor = shadowColor;
            context.shadowBlur = shadowBlur;
          } // restore filters


          if (!isNil(filter)) {
            context.filter = filter;
          }
        }
      }
    }
  }]);

  return DefaultRenderer;
}();

DefaultRenderer = __decorate([injectable()], DefaultRenderer);

var ImagePool = /*#__PURE__*/function () {
  function ImagePool() {
    _classCallCheck(this, ImagePool);

    this.imageCache = {};
    this.patternCache = {};
  }

  _createClass(ImagePool, [{
    key: "getImageSync",
    value: function getImageSync(src) {
      return this.imageCache[src];
    }
  }, {
    key: "getOrCreateImage",
    value: function getOrCreateImage(src) {
      var _this = this;

      if (this.imageCache[src]) {
        return Promise.resolve(this.imageCache[src]);
      }

      return new Promise(function (resolve, reject) {
        var image = new Image();

        image.onload = function () {
          resolve(image);
        };

        image.onerror = function (ev) {
          reject(ev);
        };

        image.crossOrigin = 'Anonymous';
        image.src = src;
        _this.imageCache[src] = image;
      });
    }
  }, {
    key: "getPatternSync",
    value: function getPatternSync(pattern) {
      var patternKey = this.generatePatternKey(pattern);

      if (this.patternCache[patternKey]) {
        return this.patternCache[patternKey];
      }
    }
  }, {
    key: "createPattern",
    value: function createPattern(patternParams, context) {
      var _this2 = this;

      return this.getOrCreateImage(patternParams.src).then(function (image) {
        var patternKey = _this2.generatePatternKey(patternParams); // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/createPattern


        var pattern = context.createPattern(image, patternParams.repetition);

        if (pattern) {
          _this2.patternCache[patternKey] = pattern;
        }

        return _this2.patternCache[patternKey];
      });
    }
  }, {
    key: "generatePatternKey",
    value: function generatePatternKey(pattern) {
      var src = pattern.src,
          repetition = pattern.repetition;
      return "pattern-".concat(src, "-").concat(repetition);
    }
  }]);

  return ImagePool;
}();

ImagePool = __decorate([injectable()], ImagePool);

var ImageRenderer = /*#__PURE__*/function () {
  function ImageRenderer() {
    _classCallCheck(this, ImageRenderer);

    this.imagePool = void 0;
  }

  _createClass(ImageRenderer, [{
    key: "render",
    value: function render(context, attributes) {
      var _attributes$width = attributes.width,
          width = _attributes$width === void 0 ? 0 : _attributes$width,
          _attributes$height = attributes.height,
          height = _attributes$height === void 0 ? 0 : _attributes$height,
          img = attributes.img,
          sx = attributes.sx,
          sy = attributes.sy,
          swidth = attributes.swidth,
          sheight = attributes.sheight;
      var image;
      var iw = width;
      var ih = height;

      if (isString(img)) {
        // image has been loaded in `mounted` hook
        image = this.imagePool.getImageSync(img);
      } else {
        iw || (iw = img.width);
        ih || (ih = img.height);
        image = img;
      }

      if (!isNil(sx) && !isNil(sy) && !isNil(swidth) && !isNil(sheight)) {
        // context.drawImage(image, sx, sy, swidth, sheight, -anchor[0] * iw, -anchor[1] * ih, iw, ih);
        context.drawImage(image, sx, sy, swidth, sheight, 0, 0, iw, ih);
      } else {
        context.drawImage(image, 0, 0, iw, ih);
      }
    }
  }]);

  return ImageRenderer;
}();

__decorate([inject(ImagePool), __metadata("design:type", ImagePool)], ImageRenderer.prototype, "imagePool", void 0);

ImageRenderer = __decorate([injectable()], ImageRenderer);

var TextRenderer = /*#__PURE__*/function () {
  function TextRenderer() {
    _classCallCheck(this, TextRenderer);

    this.textService = void 0;
  }

  _createClass(TextRenderer, [{
    key: "render",
    value: function render(context, attributes) {
      var _attributes$text = attributes.text,
          text = _attributes$text === void 0 ? '' : _attributes$text,
          _attributes$lineWidth = attributes.lineWidth,
          lineWidth = _attributes$lineWidth === void 0 ? 0 : _attributes$lineWidth,
          textAlign = attributes.textAlign,
          textBaseline = attributes.textBaseline,
          lineJoin = attributes.lineJoin,
          _attributes$miterLimi = attributes.miterLimit,
          miterLimit = _attributes$miterLimi === void 0 ? 0 : _attributes$miterLimi,
          _attributes$padding = attributes.padding,
          padding = _attributes$padding === void 0 ? 0 : _attributes$padding,
          _attributes$letterSpa = attributes.letterSpacing,
          letterSpacing = _attributes$letterSpa === void 0 ? 0 : _attributes$letterSpa,
          stroke = attributes.stroke,
          fill = attributes.fill,
          fillOpacity = attributes.fillOpacity,
          strokeOpacity = attributes.strokeOpacity,
          opacity = attributes.opacity;

      var _this$textService$mea = this.textService.measureText(text, attributes),
          font = _this$textService$mea.font,
          lines = _this$textService$mea.lines,
          height = _this$textService$mea.height,
          lineHeight = _this$textService$mea.lineHeight;

      context.font = font;
      context.lineWidth = lineWidth;
      context.textBaseline = textBaseline;
      context.lineJoin = lineJoin;
      context.miterLimit = miterLimit;
      var linePositionY = 0; // handle vertical text baseline

      if (textBaseline === 'middle') {
        linePositionY = -height / 2 - lineHeight / 2;
      } else if (textBaseline === 'bottom' || textBaseline === 'alphabetic' || textBaseline === 'ideographic') {
        linePositionY = -height;
      } else if (textBaseline === 'top' || textBaseline === 'hanging') {
        linePositionY = -lineHeight;
      } // draw lines line by line


      for (var i = 0; i < lines.length; i++) {
        var linePositionX = lineWidth / 2;
        linePositionY += lineHeight; // no need to re-position X, cause we already set text align
        // @see https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/textAlign

        if (!isNil(stroke) && lineWidth) {
          this.drawLetterSpacing(context, lines[i], linePositionX + padding, linePositionY + padding, letterSpacing, fillOpacity, strokeOpacity, opacity, true);
        }

        if (!isNil(fill)) {
          this.drawLetterSpacing(context, lines[i], linePositionX + padding, linePositionY + padding, letterSpacing, fillOpacity, strokeOpacity, opacity);
        }
      }
    }
  }, {
    key: "drawLetterSpacing",
    value: function drawLetterSpacing(context, text, x, y, letterSpacing, fillOpacity, strokeOpacity, opacity) {
      var isStroke = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : false;

      // letterSpacing of 0 means normal
      if (letterSpacing === 0) {
        if (isStroke) {
          this.strokeText(context, text, x, y, strokeOpacity);
        } else {
          this.fillText(context, text, x, y, fillOpacity, opacity);
        }

        return;
      }

      var currentPosition = x;
      var stringArray = Array.from(text);
      var previousWidth = context.measureText(text).width;
      var currentWidth = 0;

      for (var i = 0; i < stringArray.length; ++i) {
        var currentChar = stringArray[i];

        if (isStroke) {
          this.strokeText(context, currentChar, currentPosition, y, strokeOpacity);
        } else {
          this.fillText(context, currentChar, currentPosition, y, fillOpacity, opacity);
        }

        currentWidth = context.measureText(text.substring(i + 1)).width;
        currentPosition += previousWidth - currentWidth + letterSpacing;
        previousWidth = currentWidth;
      }
    }
  }, {
    key: "fillText",
    value: function fillText(context, text, x, y, fillOpacity, opacity) {
      var applyOpacity = !isNil(fillOpacity) && fillOpacity !== 1;

      if (applyOpacity) {
        context.globalAlpha = fillOpacity;
      }

      context.fillText(text, x, y);

      if (applyOpacity) {
        context.globalAlpha = opacity;
      }
    }
  }, {
    key: "strokeText",
    value: function strokeText(context, text, x, y, strokeOpacity) {
      var applyOpacity = !isNil(strokeOpacity) && strokeOpacity !== 1;

      if (applyOpacity) {
        context.globalAlpha = strokeOpacity;
      }

      context.strokeText(text, x, y);
    }
  }]);

  return TextRenderer;
}();

__decorate([inject(TextService), __metadata("design:type", TextService)], TextRenderer.prototype, "textService", void 0);

TextRenderer = __decorate([injectable()], TextRenderer);

var StyleRendererFactory = 'StyleRendererFactory';
var StyleRenderer = 'StyleRenderer';

var GradientPool = /*#__PURE__*/function () {
  function GradientPool() {
    _classCallCheck(this, GradientPool);

    this.gradientCache = {};
  }

  _createClass(GradientPool, [{
    key: "getOrCreateGradient",
    value: function getOrCreateGradient(params, context) {
      var key = this.generateCacheKey(params);
      var type = params.type,
          x0 = params.x0,
          y0 = params.y0,
          x1 = params.x1,
          y1 = params.y1,
          steps = params.steps,
          width = params.width,
          height = params.height;

      if (this.gradientCache[key]) {
        return this.gradientCache[key];
      }

      var gradient = null;

      if (type === PARSED_COLOR_TYPE.LinearGradient) {
        // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/createLinearGradient
        gradient = context.createLinearGradient(x0 * width, y0 * height, x1 * width, y1 * height);
      } else if (type === PARSED_COLOR_TYPE.RadialGradient) {
        var r = Math.sqrt(width * width + height * height) / 2; // @see https://developer.mozilla.org/zh-CN/docs/Web/API/CanvasRenderingContext2D/createRadialGradient

        gradient = context.createRadialGradient(x0 * width, y0 * height, 0, x1 * width, y1 * height, params.r1 * r);
      }

      if (gradient) {
        steps.forEach(function (_ref) {
          var _gradient;

          var _ref2 = _slicedToArray(_ref, 2),
              offset = _ref2[0],
              color = _ref2[1];

          (_gradient = gradient) === null || _gradient === void 0 ? void 0 : _gradient.addColorStop(Number(offset), color);
        });
        this.gradientCache[key] = gradient;
      }

      return this.gradientCache[key];
    }
  }, {
    key: "generateCacheKey",
    value: function generateCacheKey(params) {
      // @ts-ignore
      var type = params.type,
          x0 = params.x0,
          y0 = params.y0,
          x1 = params.x1,
          y1 = params.y1,
          r1 = params.r1,
          steps = params.steps,
          width = params.width,
          height = params.height;
      return "gradient-".concat(type, "-").concat(x0, "-").concat(y0, "-").concat(x1, "-").concat(y1, "-").concat(r1 || 0, "-").concat(width, "-").concat(height, "-").concat(steps.map(function (step) {
        return step.join('');
      }).join('-'));
    }
  }]);

  return GradientPool;
}();

GradientPool = __decorate([injectable()], GradientPool);

function generatePath(context, parsedStyle) {
  context.beginPath();
  var _parsedStyle$r = parsedStyle.r,
      r = _parsedStyle$r === void 0 ? 0 : _parsedStyle$r;
  context.arc(r, r, r, 0, Math.PI * 2, false);
}

function generatePath$1(context, attributes) {
  var rx = attributes.rx,
      ry = attributes.ry;
  context.beginPath(); // @see https://developer.mozilla.org/en-US/docs/Web/API/CanvasRenderingContext2D/ellipse

  if (context.ellipse) {
    context.ellipse(rx, ry, rx, ry, 0, 0, Math.PI * 2, false);
  } else {
    // 如果不支持，则使用圆来绘制，进行变形
    var r = rx > ry ? rx : ry;
    var scaleX = rx > ry ? 1 : rx / ry;
    var scaleY = rx > ry ? ry / rx : 1;
    context.save();
    context.scale(scaleX, scaleY);
    context.arc(0, 0, r, 0, Math.PI * 2);
    context.closePath();
    context.restore();
  }
}

function parseRadius(radius) {
  var r1 = 0;
  var r2 = 0;
  var r3 = 0;
  var r4 = 0;

  if (isArray(radius)) {
    if (radius.length === 1) {
      r1 = r2 = r3 = r4 = radius[0];
    } else if (radius.length === 2) {
      r1 = r3 = radius[0];
      r2 = r4 = radius[1];
    } else if (radius.length === 3) {
      r1 = radius[0];
      r2 = r4 = radius[1];
      r3 = radius[2];
    } else {
      r1 = radius[0];
      r2 = radius[1];
      r3 = radius[2];
      r4 = radius[3];
    }
  } else {
    r1 = r2 = r3 = r4 = radius;
  }

  return [r1, r2, r3, r4];
}

function generatePath$2(context, attributes) {
  var _attributes$radius = attributes.radius,
      radius = _attributes$radius === void 0 ? 0 : _attributes$radius,
      _attributes$width = attributes.width,
      width = _attributes$width === void 0 ? 0 : _attributes$width,
      _attributes$height = attributes.height,
      height = _attributes$height === void 0 ? 0 : _attributes$height;
  context.beginPath();

  if (radius === 0) {
    context.rect(0, 0, width, height);
  } else {
    var _parseRadius = parseRadius(radius),
        _parseRadius2 = _slicedToArray(_parseRadius, 4),
        r1 = _parseRadius2[0],
        r2 = _parseRadius2[1],
        r3 = _parseRadius2[2],
        r4 = _parseRadius2[3];

    context.moveTo(r1, 0);
    context.lineTo(width - r2, 0);
    r2 !== 0 && context.arc(width - r2, r2, r2, -Math.PI / 2, 0);
    context.lineTo(width, height - r3);
    r3 !== 0 && context.arc(width - r3, height - r3, r3, 0, Math.PI / 2);
    context.lineTo(r4, height);
    r4 !== 0 && context.arc(r4, height - r4, r4, Math.PI / 2, Math.PI);
    context.lineTo(0, r1);
    r1 !== 0 && context.arc(r1, r1, r1, Math.PI, Math.PI * 1.5);
    context.closePath();
  }
}

function generatePath$3(context, parsedStyle) {
  var x1 = parsedStyle.x1,
      y1 = parsedStyle.y1,
      x2 = parsedStyle.x2,
      y2 = parsedStyle.y2,
      _parsedStyle$defX = parsedStyle.defX,
      defX = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
      _parsedStyle$defY = parsedStyle.defY,
      defY = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;
  context.beginPath();
  context.moveTo(x1 - defX, y1 - defY);
  context.lineTo(x2 - defX, y2 - defY);
}

function generatePath$4(context, parsedStyle) {
  var _parsedStyle$defX = parsedStyle.defX,
      x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
      _parsedStyle$defY = parsedStyle.defY,
      y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;
  var points = parsedStyle.points.points;
  var length = points.length;
  var x1 = points[0][0] - x;
  var y1 = points[0][1] - y;
  var x2 = points[length - 1][0] - x;
  var y2 = points[length - 1][1] - y;
  context.beginPath();
  context.moveTo(x1, y1);

  for (var i = 0; i < length - 1; i++) {
    var point = points[i];
    context.lineTo(point[0] - x, point[1] - y);
  }

  context.lineTo(x2, y2);
}

function generatePath$5(context, parsedStyle) {
  var _parsedStyle$defX = parsedStyle.defX,
      x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
      _parsedStyle$defY = parsedStyle.defY,
      y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;
  var points = parsedStyle.points.points;
  var length = points.length;
  var x1 = points[0][0] - x;
  var y1 = points[0][1] - y;
  var x2 = points[length - 1][0] - x;
  var y2 = points[length - 1][1] - y;
  context.beginPath();
  context.moveTo(x1, y1);

  for (var i = 0; i < length - 1; i++) {
    var point = points[i];
    context.lineTo(point[0] - x, point[1] - y);
  }

  context.lineTo(x2, y2);
  context.closePath();
}

function generatePath$6(context, parsedStyle) {
  var _parsedStyle$defX = parsedStyle.defX,
      x = _parsedStyle$defX === void 0 ? 0 : _parsedStyle$defX,
      _parsedStyle$defY = parsedStyle.defY,
      y = _parsedStyle$defY === void 0 ? 0 : _parsedStyle$defY;
  var path = parsedStyle.path.curve;
  var currentPoint = [-x, -y]; // 当前图形

  var startMovePoint = [-x, -y]; // 开始 M 的点，可能会有多个

  context.beginPath();

  for (var i = 0; i < path.length; i++) {
    var params = path[i]; // eg. M 100 200

    var command = params[0]; // V,H,S,T 都在前面被转换成标准形式

    switch (command) {
      case 'M':
        context.moveTo(params[1] - x, params[2] - y);
        startMovePoint = [params[1] - x, params[2] - y];
        break;
      // case 'L':
      //   context.lineTo(params[1]! - x, params[2]! - y);
      //   break;
      // case 'Q':
      //   context.quadraticCurveTo(params[1]! - x, params[2]! - y, params[3]! - x, params[4]! - y);
      //   break;

      case 'C':
        context.bezierCurveTo(params[1] - x, params[2] - y, params[3] - x, params[4] - y, params[5] - x, params[6] - y);
        break;
      // case 'A': {
      //   let arcParams: ArcParams;
      //   // 为了加速绘制，可以提供参数的缓存，各个图形自己缓存
      //   if (arcParamsCache) {
      //     arcParams = arcParamsCache[i];
      //     if (!arcParams) {
      //       arcParams = getArcParams(currentPoint, params, x, y);
      //       arcParamsCache[i] = arcParams;
      //     }
      //   } else {
      //     arcParams = getArcParams(currentPoint, params, x, y);
      //   }
      //   const { cx, cy, rx, ry, startAngle, endAngle, xRotation, sweepFlag } = arcParams;
      //   // 直接使用椭圆的 api
      //   if (context.ellipse) {
      //     context.ellipse(cx, cy, rx, ry, xRotation, startAngle, endAngle, !!(1 - sweepFlag));
      //   } else {
      //     // 如果不支持，则使用圆来绘制，进行变形
      //     const r = rx > ry ? rx : ry;
      //     const scaleX = rx > ry ? 1 : rx / ry;
      //     const scaleY = rx > ry ? ry / rx : 1;
      //     context.translate(cx, cy);
      //     context.rotate(xRotation);
      //     context.scale(scaleX, scaleY);
      //     context.arc(0, 0, r, startAngle, endAngle, !!(1 - sweepFlag));
      //     context.scale(1 / scaleX, 1 / scaleY);
      //     context.rotate(-xRotation);
      //     context.translate(-cx, -cy);
      //   }
      //   break;
      // }

      case 'Z':
        context.closePath();
        break;
    } // 有了 Z 后，当前节点从开始 M 的点开始


    if (command === 'Z') {
      currentPoint = startMovePoint;
    } else {
      var len = params.length;
      currentPoint = [params[len - 2] - x, params[len - 1] - y];
    }
  }
}

var PathGeneratorFactory = 'PathGeneratorFactory';
var PathGenerator = 'Path';

/**
 * Common utilities
 * @module glMatrix
 */
// Configuration Constants
var EPSILON = 0.000001;
var ARRAY_TYPE = typeof Float32Array !== 'undefined' ? Float32Array : Array;
if (!Math.hypot) Math.hypot = function () {
  var y = 0,
      i = arguments.length;

  while (i--) {
    y += arguments[i] * arguments[i];
  }

  return Math.sqrt(y);
};

/**
 * 3x3 Matrix
 * @module mat3
 */

/**
 * Creates a new identity mat3
 *
 * @returns {mat3} a new 3x3 matrix
 */

function create() {
  var out = new ARRAY_TYPE(9);

  if (ARRAY_TYPE != Float32Array) {
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
    out[5] = 0;
    out[6] = 0;
    out[7] = 0;
  }

  out[0] = 1;
  out[4] = 1;
  out[8] = 1;
  return out;
}

/**
 * Returns the translation vector component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslation,
 *  the returned vector will be the same as the translation vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive translation component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */

function getTranslation(out, mat) {
  out[0] = mat[12];
  out[1] = mat[13];
  out[2] = mat[14];
  return out;
}
/**
 * Returns the scaling factor component of a transformation
 *  matrix. If a matrix is built with fromRotationTranslationScale
 *  with a normalized Quaternion paramter, the returned vector will be
 *  the same as the scaling vector
 *  originally supplied.
 * @param  {vec3} out Vector to receive scaling factor component
 * @param  {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {vec3} out
 */

function getScaling(out, mat) {
  var m11 = mat[0];
  var m12 = mat[1];
  var m13 = mat[2];
  var m21 = mat[4];
  var m22 = mat[5];
  var m23 = mat[6];
  var m31 = mat[8];
  var m32 = mat[9];
  var m33 = mat[10];
  out[0] = Math.hypot(m11, m12, m13);
  out[1] = Math.hypot(m21, m22, m23);
  out[2] = Math.hypot(m31, m32, m33);
  return out;
}
/**
 * Returns a quaternion representing the rotational component
 *  of a transformation matrix. If a matrix is built with
 *  fromRotationTranslation, the returned quaternion will be the
 *  same as the quaternion originally supplied.
 * @param {quat} out Quaternion to receive the rotation component
 * @param {ReadonlyMat4} mat Matrix to be decomposed (input)
 * @return {quat} out
 */

function getRotation(out, mat) {
  var scaling = new ARRAY_TYPE(3);
  getScaling(scaling, mat);
  var is1 = 1 / scaling[0];
  var is2 = 1 / scaling[1];
  var is3 = 1 / scaling[2];
  var sm11 = mat[0] * is1;
  var sm12 = mat[1] * is2;
  var sm13 = mat[2] * is3;
  var sm21 = mat[4] * is1;
  var sm22 = mat[5] * is2;
  var sm23 = mat[6] * is3;
  var sm31 = mat[8] * is1;
  var sm32 = mat[9] * is2;
  var sm33 = mat[10] * is3;
  var trace = sm11 + sm22 + sm33;
  var S = 0;

  if (trace > 0) {
    S = Math.sqrt(trace + 1.0) * 2;
    out[3] = 0.25 * S;
    out[0] = (sm23 - sm32) / S;
    out[1] = (sm31 - sm13) / S;
    out[2] = (sm12 - sm21) / S;
  } else if (sm11 > sm22 && sm11 > sm33) {
    S = Math.sqrt(1.0 + sm11 - sm22 - sm33) * 2;
    out[3] = (sm23 - sm32) / S;
    out[0] = 0.25 * S;
    out[1] = (sm12 + sm21) / S;
    out[2] = (sm31 + sm13) / S;
  } else if (sm22 > sm33) {
    S = Math.sqrt(1.0 + sm22 - sm11 - sm33) * 2;
    out[3] = (sm31 - sm13) / S;
    out[0] = (sm12 + sm21) / S;
    out[1] = 0.25 * S;
    out[2] = (sm23 + sm32) / S;
  } else {
    S = Math.sqrt(1.0 + sm33 - sm11 - sm22) * 2;
    out[3] = (sm12 - sm21) / S;
    out[0] = (sm31 + sm13) / S;
    out[1] = (sm23 + sm32) / S;
    out[2] = 0.25 * S;
  }

  return out;
}

/**
 * 3 Dimensional Vector
 * @module vec3
 */

/**
 * Creates a new, empty vec3
 *
 * @returns {vec3} a new 3D vector
 */

function create$1() {
  var out = new ARRAY_TYPE(3);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
  }

  return out;
}
/**
 * Calculates the length of a vec3
 *
 * @param {ReadonlyVec3} a vector to calculate length of
 * @returns {Number} length of a
 */

function length(a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  return Math.hypot(x, y, z);
}
/**
 * Creates a new vec3 initialized with the given values
 *
 * @param {Number} x X component
 * @param {Number} y Y component
 * @param {Number} z Z component
 * @returns {vec3} a new 3D vector
 */

function fromValues(x, y, z) {
  var out = new ARRAY_TYPE(3);
  out[0] = x;
  out[1] = y;
  out[2] = z;
  return out;
}
/**
 * Normalize a vec3
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a vector to normalize
 * @returns {vec3} out
 */

function normalize(out, a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  var len = x * x + y * y + z * z;

  if (len > 0) {
    //TODO: evaluate use of glm_invsqrt here?
    len = 1 / Math.sqrt(len);
  }

  out[0] = a[0] * len;
  out[1] = a[1] * len;
  out[2] = a[2] * len;
  return out;
}
/**
 * Calculates the dot product of two vec3's
 *
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {Number} dot product of a and b
 */

function dot(a, b) {
  return a[0] * b[0] + a[1] * b[1] + a[2] * b[2];
}
/**
 * Computes the cross product of two vec3's
 *
 * @param {vec3} out the receiving vector
 * @param {ReadonlyVec3} a the first operand
 * @param {ReadonlyVec3} b the second operand
 * @returns {vec3} out
 */

function cross(out, a, b) {
  var ax = a[0],
      ay = a[1],
      az = a[2];
  var bx = b[0],
      by = b[1],
      bz = b[2];
  out[0] = ay * bz - az * by;
  out[1] = az * bx - ax * bz;
  out[2] = ax * by - ay * bx;
  return out;
}
/**
 * Alias for {@link vec3.length}
 * @function
 */

var len = length;
/**
 * Perform some operation over an array of vec3s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec3. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec3s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */

var forEach = function () {
  var vec = create$1();
  return function (a, stride, offset, count, fn, arg) {
    var i, l;

    if (!stride) {
      stride = 3;
    }

    if (!offset) {
      offset = 0;
    }

    if (count) {
      l = Math.min(count * stride + offset, a.length);
    } else {
      l = a.length;
    }

    for (i = offset; i < l; i += stride) {
      vec[0] = a[i];
      vec[1] = a[i + 1];
      vec[2] = a[i + 2];
      fn(vec, vec, arg);
      a[i] = vec[0];
      a[i + 1] = vec[1];
      a[i + 2] = vec[2];
    }

    return a;
  };
}();

/**
 * 4 Dimensional Vector
 * @module vec4
 */

/**
 * Creates a new, empty vec4
 *
 * @returns {vec4} a new 4D vector
 */

function create$2() {
  var out = new ARRAY_TYPE(4);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
    out[3] = 0;
  }

  return out;
}
/**
 * Normalize a vec4
 *
 * @param {vec4} out the receiving vector
 * @param {ReadonlyVec4} a vector to normalize
 * @returns {vec4} out
 */

function normalize$1(out, a) {
  var x = a[0];
  var y = a[1];
  var z = a[2];
  var w = a[3];
  var len = x * x + y * y + z * z + w * w;

  if (len > 0) {
    len = 1 / Math.sqrt(len);
  }

  out[0] = x * len;
  out[1] = y * len;
  out[2] = z * len;
  out[3] = w * len;
  return out;
}
/**
 * Perform some operation over an array of vec4s.
 *
 * @param {Array} a the array of vectors to iterate over
 * @param {Number} stride Number of elements between the start of each vec4. If 0 assumes tightly packed
 * @param {Number} offset Number of elements to skip at the beginning of the array
 * @param {Number} count Number of vec4s to iterate over. If 0 iterates over entire array
 * @param {Function} fn Function to call for each vector in the array
 * @param {Object} [arg] additional argument to pass to fn
 * @returns {Array} a
 * @function
 */

var forEach$1 = function () {
  var vec = create$2();
  return function (a, stride, offset, count, fn, arg) {
    var i, l;

    if (!stride) {
      stride = 4;
    }

    if (!offset) {
      offset = 0;
    }

    if (count) {
      l = Math.min(count * stride + offset, a.length);
    } else {
      l = a.length;
    }

    for (i = offset; i < l; i += stride) {
      vec[0] = a[i];
      vec[1] = a[i + 1];
      vec[2] = a[i + 2];
      vec[3] = a[i + 3];
      fn(vec, vec, arg);
      a[i] = vec[0];
      a[i + 1] = vec[1];
      a[i + 2] = vec[2];
      a[i + 3] = vec[3];
    }

    return a;
  };
}();

/**
 * Quaternion
 * @module quat
 */

/**
 * Creates a new identity quat
 *
 * @returns {quat} a new quaternion
 */

function create$3() {
  var out = new ARRAY_TYPE(4);

  if (ARRAY_TYPE != Float32Array) {
    out[0] = 0;
    out[1] = 0;
    out[2] = 0;
  }

  out[3] = 1;
  return out;
}
/**
 * Sets a quat from the given angle and rotation axis,
 * then returns it.
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyVec3} axis the axis around which to rotate
 * @param {Number} rad the angle in radians
 * @returns {quat} out
 **/

function setAxisAngle(out, axis, rad) {
  rad = rad * 0.5;
  var s = Math.sin(rad);
  out[0] = s * axis[0];
  out[1] = s * axis[1];
  out[2] = s * axis[2];
  out[3] = Math.cos(rad);
  return out;
}
/**
 * Performs a spherical linear interpolation between two quat
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a the first operand
 * @param {ReadonlyQuat} b the second operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {quat} out
 */

function slerp(out, a, b, t) {
  // benchmarks:
  //    http://jsperf.com/quaternion-slerp-implementations
  var ax = a[0],
      ay = a[1],
      az = a[2],
      aw = a[3];
  var bx = b[0],
      by = b[1],
      bz = b[2],
      bw = b[3];
  var omega, cosom, sinom, scale0, scale1; // calc cosine

  cosom = ax * bx + ay * by + az * bz + aw * bw; // adjust signs (if necessary)

  if (cosom < 0.0) {
    cosom = -cosom;
    bx = -bx;
    by = -by;
    bz = -bz;
    bw = -bw;
  } // calculate coefficients


  if (1.0 - cosom > EPSILON) {
    // standard case (slerp)
    omega = Math.acos(cosom);
    sinom = Math.sin(omega);
    scale0 = Math.sin((1.0 - t) * omega) / sinom;
    scale1 = Math.sin(t * omega) / sinom;
  } else {
    // "from" and "to" quaternions are very close
    //  ... so we can do a linear interpolation
    scale0 = 1.0 - t;
    scale1 = t;
  } // calculate final values


  out[0] = scale0 * ax + scale1 * bx;
  out[1] = scale0 * ay + scale1 * by;
  out[2] = scale0 * az + scale1 * bz;
  out[3] = scale0 * aw + scale1 * bw;
  return out;
}
/**
 * Creates a quaternion from the given 3x3 rotation matrix.
 *
 * NOTE: The resultant quaternion is not normalized, so you should be sure
 * to renormalize the quaternion yourself where necessary.
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyMat3} m rotation matrix
 * @returns {quat} out
 * @function
 */

function fromMat3(out, m) {
  // Algorithm in Ken Shoemake's article in 1987 SIGGRAPH course notes
  // article "Quaternion Calculus and Fast Animation".
  var fTrace = m[0] + m[4] + m[8];
  var fRoot;

  if (fTrace > 0.0) {
    // |w| > 1/2, may as well choose w > 1/2
    fRoot = Math.sqrt(fTrace + 1.0); // 2w

    out[3] = 0.5 * fRoot;
    fRoot = 0.5 / fRoot; // 1/(4w)

    out[0] = (m[5] - m[7]) * fRoot;
    out[1] = (m[6] - m[2]) * fRoot;
    out[2] = (m[1] - m[3]) * fRoot;
  } else {
    // |w| <= 1/2
    var i = 0;
    if (m[4] > m[0]) i = 1;
    if (m[8] > m[i * 3 + i]) i = 2;
    var j = (i + 1) % 3;
    var k = (i + 2) % 3;
    fRoot = Math.sqrt(m[i * 3 + i] - m[j * 3 + j] - m[k * 3 + k] + 1.0);
    out[i] = 0.5 * fRoot;
    fRoot = 0.5 / fRoot;
    out[3] = (m[j * 3 + k] - m[k * 3 + j]) * fRoot;
    out[j] = (m[j * 3 + i] + m[i * 3 + j]) * fRoot;
    out[k] = (m[k * 3 + i] + m[i * 3 + k]) * fRoot;
  }

  return out;
}
/**
 * Normalize a quat
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a quaternion to normalize
 * @returns {quat} out
 * @function
 */

var normalize$2 = normalize$1;
/**
 * Sets a quaternion to represent the shortest rotation from one
 * vector to another.
 *
 * Both vectors are assumed to be unit length.
 *
 * @param {quat} out the receiving quaternion.
 * @param {ReadonlyVec3} a the initial vector
 * @param {ReadonlyVec3} b the destination vector
 * @returns {quat} out
 */

var rotationTo = function () {
  var tmpvec3 = create$1();
  var xUnitVec3 = fromValues(1, 0, 0);
  var yUnitVec3 = fromValues(0, 1, 0);
  return function (out, a, b) {
    var dot$1 = dot(a, b);

    if (dot$1 < -0.999999) {
      cross(tmpvec3, xUnitVec3, a);
      if (len(tmpvec3) < 0.000001) cross(tmpvec3, yUnitVec3, a);
      normalize(tmpvec3, tmpvec3);
      setAxisAngle(out, tmpvec3, Math.PI);
      return out;
    } else if (dot$1 > 0.999999) {
      out[0] = 0;
      out[1] = 0;
      out[2] = 0;
      out[3] = 1;
      return out;
    } else {
      cross(tmpvec3, a, b);
      out[0] = tmpvec3[0];
      out[1] = tmpvec3[1];
      out[2] = tmpvec3[2];
      out[3] = 1 + dot$1;
      return normalize$2(out, out);
    }
  };
}();
/**
 * Performs a spherical linear interpolation with two control points
 *
 * @param {quat} out the receiving quaternion
 * @param {ReadonlyQuat} a the first operand
 * @param {ReadonlyQuat} b the second operand
 * @param {ReadonlyQuat} c the third operand
 * @param {ReadonlyQuat} d the fourth operand
 * @param {Number} t interpolation amount, in the range [0-1], between the two inputs
 * @returns {quat} out
 */

var sqlerp = function () {
  var temp1 = create$3();
  var temp2 = create$3();
  return function (out, a, b, c, d, t) {
    slerp(temp1, a, d, t);
    slerp(temp2, b, c, t);
    slerp(out, temp1, temp2, 2 * t * (1 - t));
    return out;
  };
}();
/**
 * Sets the specified quaternion with values corresponding to the given
 * axes. Each axis is a vec3 and is expected to be unit length and
 * perpendicular to all other specified axes.
 *
 * @param {ReadonlyVec3} view  the vector representing the viewing direction
 * @param {ReadonlyVec3} right the vector representing the local "right" direction
 * @param {ReadonlyVec3} up    the vector representing the local "up" direction
 * @returns {quat} out
 */

var setAxes = function () {
  var matr = create();
  return function (out, view, right, up) {
    matr[0] = right[0];
    matr[3] = right[1];
    matr[6] = right[2];
    matr[1] = up[0];
    matr[4] = up[1];
    matr[7] = up[2];
    matr[2] = -view[0];
    matr[5] = -view[1];
    matr[8] = -view[2];
    return normalize$2(out, fromMat3(out, matr));
  };
}();

var RBushNode = /*#__PURE__*/function (_Component) {
  _inherits(RBushNode, _Component);

  var _super = _createSuper(RBushNode);

  function RBushNode() {
    var _this;

    _classCallCheck(this, RBushNode);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _super.call.apply(_super, [this].concat(args));
    _this.aabb = void 0;
    return _this;
  }

  return RBushNode;
}(Component);
RBushNode.tag = 'c-canvas-rbush-node';

var _class, _temp;

var CanvasRendererPlugin_1, _a;
var RBushRoot = 'RBushRoot';
var SHAPE_ATTRS_MAP = {
  fill: 'fillStyle',
  stroke: 'strokeStyle',
  opacity: 'globalAlpha'
};
/**
 * support 2 modes in rendering:
 * * immediate
 * * delayed: render at the end of frame with dirty-rectangle
 */

var CanvasRendererPlugin = CanvasRendererPlugin_1 = (_temp = _class = /*#__PURE__*/function () {
  function CanvasRendererPlugin() {
    var _this = this;

    _classCallCheck(this, CanvasRendererPlugin);

    this.canvasConfig = void 0;
    this.camera = void 0;
    this.contextService = void 0;
    this.sceneGraphService = void 0;
    this.renderingContext = void 0;
    this.imagePool = void 0;
    this.gradientPool = void 0;
    this.pathGeneratorFactory = void 0;
    this.styleRendererFactory = void 0;
    this.displayObjectPool = void 0;
    this.rBush = void 0;
    this.renderQueue = [];
    this.restoreStack = [];
    this.clearFullScreen = false;
    this.lastDirtyRectangle = void 0;

    this.handleEntityAABBChanged = function (object) {
      // skip if this object mounted on another scenegraph root
      if (object.ownerDocument !== _this.renderingContext.root) {
        return;
      }

      var entity = object.getEntity();

      var _this$canvasConfig$re = _this.canvasConfig.renderer.getConfig(),
          enableDirtyRectangleRendering = _this$canvasConfig$re.enableDirtyRectangleRendering; // don not use rbush when dirty-rectangle rendering disabled


      if (!enableDirtyRectangleRendering) {
        return;
      }

      var renderable = entity.getComponent(Renderable);

      if (!entity.hasComponent(RBushNode)) {
        return;
      }

      var rBushNode = entity.getComponent(RBushNode);

      if (rBushNode) {
        // insert node in RTree
        if (rBushNode.aabb) {
          _this.rBush.remove(rBushNode.aabb);
        }

        if (renderable.aabb) {
          var _renderable$aabb$getM = renderable.aabb.getMin(),
              _renderable$aabb$getM2 = _slicedToArray(_renderable$aabb$getM, 2),
              minX = _renderable$aabb$getM2[0],
              minY = _renderable$aabb$getM2[1];

          var _renderable$aabb$getM3 = renderable.aabb.getMax(),
              _renderable$aabb$getM4 = _slicedToArray(_renderable$aabb$getM3, 2),
              maxX = _renderable$aabb$getM4[0],
              maxY = _renderable$aabb$getM4[1];

          rBushNode.aabb = {
            name: entity.getName(),
            minX: minX,
            minY: minY,
            maxX: maxX,
            maxY: maxY
          };
        }

        _this.rBush.insert(rBushNode.aabb);
      }
    };
  }

  _createClass(CanvasRendererPlugin, [{
    key: "apply",
    value: function apply(renderingService) {
      var _this2 = this;

      renderingService.hooks.init.tap(CanvasRendererPlugin_1.tag, function () {
        var context = _this2.contextService.getContext();

        var dpr = _this2.contextService.getDPR(); // scale all drawing operations by the dpr
        // @see https://www.html5rocks.com/en/tutorials/canvas/hidpi/


        context && context.scale(dpr, dpr);

        _this2.sceneGraphService.on(SCENE_GRAPH_EVENT.AABBChanged, _this2.handleEntityAABBChanged);
      });
      renderingService.hooks.mounted.tap(CanvasRendererPlugin_1.tag, function (object) {
        object.getEntity().addComponent(RBushNode);

        _this2.sceneGraphService.emit(SCENE_GRAPH_EVENT.AABBChanged, object);
      });
      renderingService.hooks.unmounted.tap(CanvasRendererPlugin_1.tag, function (object) {
        var rBushNode = object.getEntity().getComponent(RBushNode);

        _this2.rBush.remove(rBushNode.aabb);

        object.getEntity().removeComponent(RBushNode);
      });
      renderingService.hooks.destroy.tap(CanvasRendererPlugin_1.tag, function () {
        _this2.sceneGraphService.off(SCENE_GRAPH_EVENT.AABBChanged, _this2.handleEntityAABBChanged);
      });
      renderingService.hooks.beginFrame.tap(CanvasRendererPlugin_1.tag, function () {
        var context = _this2.contextService.getContext();

        var _this2$canvasConfig$r = _this2.canvasConfig.renderer.getConfig(),
            enableDirtyRectangleRendering = _this2$canvasConfig$r.enableDirtyRectangleRendering,
            enableDirtyRectangleRenderingDebug = _this2$canvasConfig$r.enableDirtyRectangleRenderingDebug; // clear fullscreen when:
        // 1. dirty rectangle rendering disabled
        // 2. camera changed


        _this2.clearFullScreen = !enableDirtyRectangleRendering || _this2.renderingContext.renderReasons.has(RENDER_REASON.CameraChanged);

        if (context) {
          context.save();

          if (_this2.clearFullScreen) {
            context.clearRect(0, 0, _this2.canvasConfig.width, _this2.canvasConfig.height);
          } // account for camera's world matrix


          _this2.applyTransform(context, _this2.camera.getOrthoMatrix());
        }
      }); // render at the end of frame

      renderingService.hooks.endFrame.tap(CanvasRendererPlugin_1.tag, function () {
        var _this2$canvasConfig$r2 = _this2.canvasConfig.renderer.getConfig(),
            enableDirtyRectangleRendering = _this2$canvasConfig$r2.enableDirtyRectangleRendering;

        var context = _this2.contextService.getContext();

        if (enableDirtyRectangleRendering) {
          // merge removed AABB
          var dirtyAABB = _this2.safeMergeAABB.apply(_this2, [_this2.mergeDirtyAABBs(_this2.renderQueue)].concat(_toConsumableArray(_this2.renderingContext.removedAABBs)));

          _this2.renderingContext.removedAABBs = [];

          if (!dirtyAABB) {
            return;
          } // clear & clip dirty rectangle


          var _this2$convertAABB2Re = _this2.convertAABB2Rect(dirtyAABB),
              x = _this2$convertAABB2Re.x,
              y = _this2$convertAABB2Re.y,
              width = _this2$convertAABB2Re.width,
              height = _this2$convertAABB2Re.height;

          context.clearRect(x, y, width, height);
          context.beginPath();
          context.rect(x, y, width, height);
          context.clip(); // search objects intersect with dirty rectangle

          var dirtyObjects = _this2.searchDirtyObjects(dirtyAABB); // append uncullable objects in renderQueue


          var uncullableObjects = _this2.renderQueue.filter(function (object) {
            return !object.getEntity().getComponent(Cullable).enable;
          });

          dirtyObjects.push.apply(dirtyObjects, _toConsumableArray(uncullableObjects)); // do rendering

          dirtyObjects // sort by z-index
          .sort(_this2.sceneGraphService.sort).forEach(function (object) {
            if (object.isVisible()) {
              _this2.renderDisplayObject(object, renderingService);
            }
          }); // save dirty AABBs in last frame

          _this2.renderQueue.forEach(function (object) {
            _this2.saveDirtyAABB(object);
          }); // pop restore stack, eg. root -> parent -> child


          _this2.restoreStack.forEach(function (s) {
            context.restore();
          }); // clear queue


          _this2.renderQueue = []; // clear restore stack

          _this2.restoreStack = [];
        }

        context.restore();
      });
      renderingService.hooks.render.tap(CanvasRendererPlugin_1.tag, function (object) {
        var _this2$canvasConfig$r3 = _this2.canvasConfig.renderer.getConfig(),
            enableDirtyRectangleRendering = _this2$canvasConfig$r3.enableDirtyRectangleRendering;

        if (!enableDirtyRectangleRendering) {
          // render immediately
          _this2.renderDisplayObject(object, renderingService);
        } else {
          // render at the end of frame
          _this2.renderQueue.push(object);
        }
      });
    }
  }, {
    key: "renderDisplayObject",
    value: function renderDisplayObject(object, renderingService) {
      var _this3 = this;

      var context = this.contextService.getContext(); // restore to its parent

      var parent = this.restoreStack[this.restoreStack.length - 1];

      while (parent && object.parent !== parent) {
        context.restore();
        this.restoreStack.pop();
        parent = this.restoreStack[this.restoreStack.length - 1];
      }

      var nodeName = object.nodeName; // reset transformation

      context.save(); // apply RTS transformation in world space

      this.applyTransform(context, object.getLocalTransform()); // clip path

      var clipPathShape = object.style.clipPath;

      if (clipPathShape) {
        context.save(); // apply clip shape's RTS

        this.applyTransform(context, clipPathShape.getLocalTransform()); // generate path in local space

        var generatePath = this.pathGeneratorFactory(clipPathShape.nodeName);

        if (generatePath) {
          this.useAnchor(context, clipPathShape, function () {
            generatePath(context, clipPathShape.parsedStyle);
          });
        }

        context.restore();
        context.clip();
      } // apply attributes to context


      this.applyAttributesToContext(context, object, renderingService); // apply anchor in local space

      this.useAnchor(context, object, function () {
        // generate path in local space
        var generatePath = _this3.pathGeneratorFactory(object.nodeName);

        if (generatePath) {
          generatePath(context, object.parsedStyle);
        } // fill & stroke


        var styleRenderer = _this3.styleRendererFactory(nodeName);

        if (styleRenderer) {
          styleRenderer.render(context, object.parsedStyle, object);
        }
      }); // finish rendering, clear dirty flag

      var renderable = object.getEntity().getComponent(Renderable);
      renderable.dirty = false;
      this.restoreStack.push(object);
    }
  }, {
    key: "convertAABB2Rect",
    value: function convertAABB2Rect(aabb) {
      var min = aabb.getMin();
      var max = aabb.getMax(); // expand the rectangle a bit to avoid artifacts
      // @see https://www.yuque.com/antv/ou292n/bi8nix#ExvCu

      var minX = Math.floor(min[0]);
      var minY = Math.floor(min[1]);
      var maxX = Math.ceil(max[0]);
      var maxY = Math.ceil(max[1]);
      var width = maxX - minX;
      var height = maxY - minY;
      return {
        x: minX,
        y: minY,
        width: width,
        height: height
      };
    }
    /**
     * TODO: merge dirty rectangles with some strategies.
     * For now, we just simply merge all the rectangles into one.
     * @see https://idom.me/articles/841.html
     */

  }, {
    key: "mergeDirtyAABBs",
    value: function mergeDirtyAABBs(dirtyObjects) {
      // merge into a big AABB
      var dirtyRectangle;
      dirtyObjects.forEach(function (object) {
        var aabb = object.getBounds();

        if (aabb) {
          if (!dirtyRectangle) {
            dirtyRectangle = new AABB(aabb.center, aabb.halfExtents);
          } else {
            dirtyRectangle.add(aabb);
          }
        }

        var _object$getEntity$get = object.getEntity().getComponent(Renderable),
            dirtyAABB = _object$getEntity$get.dirtyAABB;

        if (dirtyAABB) {
          if (!dirtyRectangle) {
            dirtyRectangle = new AABB(dirtyAABB.center, dirtyAABB.halfExtents);
          } else {
            dirtyRectangle.add(dirtyAABB);
          }
        }
      });
      return dirtyRectangle;
    }
  }, {
    key: "searchDirtyObjects",
    value: function searchDirtyObjects(dirtyRectangle) {
      var _this4 = this;

      // search in r-tree, get all affected nodes
      var _dirtyRectangle$getMi = dirtyRectangle.getMin(),
          _dirtyRectangle$getMi2 = _slicedToArray(_dirtyRectangle$getMi, 2),
          minX = _dirtyRectangle$getMi2[0],
          minY = _dirtyRectangle$getMi2[1];

      var _dirtyRectangle$getMa = dirtyRectangle.getMax(),
          _dirtyRectangle$getMa2 = _slicedToArray(_dirtyRectangle$getMa, 2),
          maxX = _dirtyRectangle$getMa2[0],
          maxY = _dirtyRectangle$getMa2[1];

      var rBushNodes = this.rBush.search({
        minX: minX,
        minY: minY,
        maxX: maxX,
        maxY: maxY
      });
      return rBushNodes.map(function (_ref) {
        var name = _ref.name;
        return _this4.displayObjectPool.getByName(name);
      });
    }
  }, {
    key: "saveDirtyAABB",
    value: function saveDirtyAABB(object) {
      var entity = object.getEntity();
      var renderable = entity.getComponent(Renderable);

      if (!renderable.dirtyAABB) {
        renderable.dirtyAABB = new AABB();
      }

      var bounds = object.getBounds();

      if (bounds) {
        // save last dirty aabb
        renderable.dirtyAABB.update(bounds.center, bounds.halfExtents);
      }
    }
  }, {
    key: "drawDirtyRectangle",
    value: function drawDirtyRectangle(context, _ref2) {
      var x = _ref2.x,
          y = _ref2.y,
          width = _ref2.width,
          height = _ref2.height;
      context.beginPath();
      context.rect(x + 1, y + 1, width - 1, height - 1);
      context.closePath();
      context.lineWidth = 1;
      context.stroke();
    }
  }, {
    key: "applyTransform",
    value: function applyTransform(context, transform) {
      var _mat4$getTranslation = getTranslation(create$1(), transform),
          _mat4$getTranslation2 = _slicedToArray(_mat4$getTranslation, 2),
          tx = _mat4$getTranslation2[0],
          ty = _mat4$getTranslation2[1];

      var _mat4$getScaling = getScaling(create$1(), transform),
          _mat4$getScaling2 = _slicedToArray(_mat4$getScaling, 2),
          sx = _mat4$getScaling2[0],
          sy = _mat4$getScaling2[1];

      var rotation = getRotation(create$3(), transform);

      var _getEuler = getEuler(create$1(), rotation),
          _getEuler2 = _slicedToArray(_getEuler, 3),
          eux = _getEuler2[0],
          euy = _getEuler2[1],
          euz = _getEuler2[2]; // gimbal lock at 90 degrees


      var rts = fromRotationTranslationScale(eux || euz, tx, ty, sx, sy); // @see https://developer.mozilla.org/en-US/docs/Web/API/Canvas_API/Tutorial/Transformations

      context.transform(rts[0], rts[1], rts[3], rts[4], rts[6], rts[7]);
    }
  }, {
    key: "applyAttributesToContext",
    value: function applyAttributesToContext(context, object, renderingService) {
      var attributes = object.attributes,
          parsedStyle = object.parsedStyle;

      for (var k in attributes) {
        // reserved keywords in Canvas2DContext
        if (k === 'transform') {
          continue;
        }

        var v = attributes[k]; // 转换一下不与 canvas 兼容的属性名

        var name = SHAPE_ATTRS_MAP[k] ? SHAPE_ATTRS_MAP[k] : k;

        if (name === 'lineDash' && context.setLineDash) {
          isArray(v) && context.setLineDash(v);
        } else {
          if (name === 'strokeStyle' || name === 'fillStyle') {
            var parsedColor = parsedStyle[k];

            if (parsedColor.type === PARSED_COLOR_TYPE.LinearGradient || parsedColor.type === PARSED_COLOR_TYPE.RadialGradient) {
              var _parsedStyle$width = parsedStyle.width,
                  width = _parsedStyle$width === void 0 ? 0 : _parsedStyle$width,
                  _parsedStyle$height = parsedStyle.height,
                  height = _parsedStyle$height === void 0 ? 0 : _parsedStyle$height;
              v = this.gradientPool.getOrCreateGradient(_objectSpread2(_objectSpread2({
                type: parsedColor.type
              }, parsedColor.value), {}, {
                width: width,
                height: height
              }), context);
            } else if (parsedColor.type === PARSED_COLOR_TYPE.Pattern) {
              var pattern = this.imagePool.getPatternSync(parsedColor.value);

              if (pattern) {
                v = pattern;
              } else {
                this.imagePool.createPattern(parsedColor.value, context).then(function () {
                  // set dirty rectangle flag
                  object.getEntity().getComponent(Renderable).dirty = true;
                  renderingService.dirtify();
                });
              }
            } else {
              // constant, eg. rgba(255,255,255,1)
              v = parsedColor.formatted;
            }
          } else if (name === 'globalAlpha') {
            // opacity 效果可以叠加，子元素的 opacity 需要与父元素 opacity 相乘
            v = v * context.globalAlpha;
          } // @ts-ignore


          context[name] = v;
        }
      }
    }
  }, {
    key: "useAnchor",
    value: function useAnchor(context, object, callback) {
      context.save(); // apply anchor, use true size, not include stroke,
      // eg. bounds = true size + half lineWidth

      var _ref3 = object.parsedStyle || {},
          _ref3$width = _ref3.width,
          width = _ref3$width === void 0 ? 0 : _ref3$width,
          _ref3$height = _ref3.height,
          height = _ref3$height === void 0 ? 0 : _ref3$height,
          _ref3$anchor = _ref3.anchor,
          anchor = _ref3$anchor === void 0 ? [0, 0] : _ref3$anchor;

      context.translate(-anchor[0] * width, -anchor[1] * height);
      callback();
      context.restore();
    }
  }, {
    key: "safeMergeAABB",
    value: function safeMergeAABB() {
      var merged;

      for (var _len = arguments.length, aabbs = new Array(_len), _key = 0; _key < _len; _key++) {
        aabbs[_key] = arguments[_key];
      }

      aabbs.forEach(function (aabb) {
        if (aabb) {
          if (!merged) {
            merged = aabb;
          } else {
            merged.add(aabb);
          }
        }
      });
      return merged;
    }
  }]);

  return CanvasRendererPlugin;
}(), _class.tag = 'CanvasRendererPlugin', _temp);

__decorate([inject(CanvasConfig), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "canvasConfig", void 0);

__decorate([inject(DefaultCamera), __metadata("design:type", Camera)], CanvasRendererPlugin.prototype, "camera", void 0);

__decorate([inject(ContextService), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "contextService", void 0);

__decorate([inject(SceneGraphService), __metadata("design:type", SceneGraphService)], CanvasRendererPlugin.prototype, "sceneGraphService", void 0);

__decorate([inject(RenderingContext), __metadata("design:type", Object)], CanvasRendererPlugin.prototype, "renderingContext", void 0);

__decorate([inject(ImagePool), __metadata("design:type", ImagePool)], CanvasRendererPlugin.prototype, "imagePool", void 0);

__decorate([inject(GradientPool), __metadata("design:type", GradientPool)], CanvasRendererPlugin.prototype, "gradientPool", void 0);

__decorate([inject(PathGeneratorFactory), __metadata("design:type", Function)], CanvasRendererPlugin.prototype, "pathGeneratorFactory", void 0);

__decorate([inject(StyleRendererFactory), __metadata("design:type", Function)], CanvasRendererPlugin.prototype, "styleRendererFactory", void 0);

__decorate([inject(DisplayObjectPool), __metadata("design:type", DisplayObjectPool)], CanvasRendererPlugin.prototype, "displayObjectPool", void 0);

__decorate([inject(RBushRoot), __metadata("design:type", typeof (_a = typeof RBush !== "undefined" && RBush) === "function" ? _a : Object)], CanvasRendererPlugin.prototype, "rBush", void 0);

CanvasRendererPlugin = CanvasRendererPlugin_1 = __decorate([injectable()], CanvasRendererPlugin);

var _class$1, _temp$1;

var LoadImagePlugin_1;
var LoadImagePlugin = LoadImagePlugin_1 = (_temp$1 = _class$1 = /*#__PURE__*/function () {
  function LoadImagePlugin() {
    _classCallCheck(this, LoadImagePlugin);

    this.imagePool = void 0;
  }

  _createClass(LoadImagePlugin, [{
    key: "apply",
    value: function apply(renderingService) {
      var _this = this;

      renderingService.hooks.mounted.tap(LoadImagePlugin_1.tag, function (object) {
        var nodeName = object.nodeName,
            attributes = object.attributes;

        if (nodeName === SHAPE.Image) {
          var img = attributes.img;

          if (isString(img)) {
            _this.imagePool.getOrCreateImage(img).then(function () {
              // set dirty rectangle flag
              object.getEntity().getComponent(Renderable).dirty = true;
              renderingService.dirtify();
            });
          }
        }
      });
      renderingService.hooks.attributeChanged.tap(LoadImagePlugin_1.tag, function (object, name, value) {
        var nodeName = object.nodeName;

        if (nodeName === SHAPE.Image) {
          if (name === 'img') {
            if (isString(value)) {
              _this.imagePool.getOrCreateImage(value).then(function () {
                // set dirty rectangle flag
                object.getEntity().getComponent(Renderable).dirty = true;
                renderingService.dirtify();
              });
            }
          }
        }
      });
    }
  }]);

  return LoadImagePlugin;
}(), _class$1.tag = 'LoadImagePlugin', _temp$1);

__decorate([inject(ImagePool), __metadata("design:type", ImagePool)], LoadImagePlugin.prototype, "imagePool", void 0);

LoadImagePlugin = LoadImagePlugin_1 = __decorate([injectable()], LoadImagePlugin);

world.registerComponent(RBushNode);
/**
 * register shape renderers
 */

container.bind(PathGenerator).toConstantValue(generatePath).whenTargetNamed(SHAPE.Circle);
container.bind(PathGenerator).toConstantValue(generatePath$1).whenTargetNamed(SHAPE.Ellipse);
container.bind(PathGenerator).toConstantValue(generatePath$2).whenTargetNamed(SHAPE.Rect);
container.bind(PathGenerator).toConstantValue(generatePath$3).whenTargetNamed(SHAPE.Line);
container.bind(PathGenerator).toConstantValue(generatePath$4).whenTargetNamed(SHAPE.Polyline);
container.bind(PathGenerator).toConstantValue(generatePath$5).whenTargetNamed(SHAPE.Polygon);
container.bind(PathGenerator).toConstantValue(generatePath$6).whenTargetNamed(SHAPE.Path);
container.bind(PathGeneratorFactory).toFactory(function (ctx) {
  return function (tagName) {
    if (ctx.container.isBoundNamed(PathGenerator, tagName)) {
      return ctx.container.getNamed(PathGenerator, tagName);
    }

    return null;
  };
});
var containerModule = new ContainerModule(function (bind, unbind, isBound, rebind) {
  bind(ImagePool).toSelf().inSingletonScope();
  bind(RBushRoot).toConstantValue(new RBush());
  bind(DefaultRenderer).toSelf().inSingletonScope();
  bind(ImageRenderer).toSelf().inSingletonScope();
  bind(TextRenderer).toSelf().inSingletonScope();
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Circle);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Ellipse);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Rect);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Line);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Polyline);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Polygon);
  bind(StyleRenderer).to(DefaultRenderer).inSingletonScope().whenTargetNamed(SHAPE.Path);
  bind(StyleRenderer).to(ImageRenderer).inSingletonScope().whenTargetNamed(SHAPE.Image);
  bind(StyleRenderer).to(TextRenderer).inSingletonScope().whenTargetNamed(SHAPE.Text);
  bind(StyleRendererFactory).toFactory(function (ctx) {
    return function (tagName) {
      if (ctx.container.isBoundNamed(StyleRenderer, tagName)) {
        return ctx.container.getNamed(StyleRenderer, tagName);
      }

      return null;
    };
  });
  bind(GradientPool).toSelf().inSingletonScope();
  bind(CanvasRendererPlugin).toSelf().inSingletonScope();
  bind(RenderingPluginContribution).toService(CanvasRendererPlugin);
  bind(LoadImagePlugin).toSelf().inSingletonScope();
  bind(RenderingPluginContribution).toService(LoadImagePlugin);
});
var Plugin = /*#__PURE__*/function () {
  function Plugin() {
    _classCallCheck(this, Plugin);
  }

  _createClass(Plugin, [{
    key: "init",
    value: function init(container) {
      container.load(containerModule);
    }
  }, {
    key: "destroy",
    value: function destroy(container) {
      container.unload(containerModule);
    }
  }]);

  return Plugin;
}();

export { PathGenerator, PathGeneratorFactory, Plugin, RBushNode, RBushRoot, StyleRenderer };
